// Enkel fysisk modellering

// inn og ut
inlets = 4;
outlets = 2;

//globale variabler
var tsk = new Task(mytask, this);
var count = 0;
var decay = 1.0;
var oktav = 12;
var q = -1;

// argumenter
var dcoeff = -0.0002; // descay koeffisient
var note = 60; // note to trigger bounce

// tar inn argumnentverdier
if(jsarguments.length>1) {
	dcoeff = jsarguments[1];
}
if(jsarguments.length>2) {
	note = jsarguments[2];
}

// Max-globale variabler
glob = new Global("bounce");
glob.starttime = 500;

//////////////////////////////////////////////////////////////////////

function bang() {
	tsk.cancel(); // avslutter bouncing hvis den er i gang
	count = 0; // nullstiller bounce-nummer
	decay = 1.0; // tilbakestiller decay
	tsk.interval = glob.starttime; // starttiden til task
	tsk.repeat(); // starter bouncing
}

function stop() {
	tsk.cancel(); // stopper metoden
}

function key(a) {
	note = a-35; // trekker fra litt for  tilpasse til MIDI
}

function decaycoeff(b) {
	dcoeff = b;
}

function mytask() {
	if (arguments.callee.task.interval>5) { // keep bouncing
		outlet(0, note); // send ut noteverdi
		decay = decay*Math.exp(++count*dcoeff); // regner ut decay
		arguments.callee.task.interval=arguments.callee.task.interval*decay
		note = note + 2;
	} else {  // kutter ut hvis vi nrmer oss bunnen
		arguments.callee.task.cancel();// avslutte
		outlet(1, bang); // sender ut bang for  si at vi er ferdig
	}
}


mytask.local = 1; // for  unng trigging direkte fra Max
		
